/*
 *  Instance.h
 *  Assignment9
 *
 *  Created by Zach Gildersleeve on 4/8/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef INSTANCE_H
#define INSTANCE_H

#include "Primitive.h"
#include "Matrix.h"
static const double convert = 0.01745329252;

class Instance : public Primitive {
	public:
		Instance();
		~Instance() {}
		Instance(Primitive *newObject);
		Instance(Primitive *newObject,
				 double newX, double newY, double newZ,
				 double newXangle, double newYangle, double newZangle,
				 double newXscale, double newYscale, double newZscale);
				 
		void setPosition(double newX, double newY, double newZ);
		void setRotation(double newXangle, double newYangle, double newZangle);
		void setScale(double newXscale, double newYscale, double newZscale);

		void preprocess();
		virtual void getTextCoord(Vector &textCoord, const RenderContext &context, const Ray &ray, const HitRecord &hit) const;
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		virtual void normal(Vector &normal, const Point &hitPoint, const HitRecord &hit,
							const RenderContext &context, const Ray &ray) const;
		virtual void getBounds(BoundingBox& bbox) const;
		
	private:

		Primitive *object;
		mutable const Primitive *currentPrimitive;
		Matrix transMat;
		Matrix invTransMat;
		double x;
		double y;
		double z;
		double xAngle;
		double yAngle;
		double zAngle;
		double xScale;
		double yScale;
		double zScale;
};

#endif
