/*
 *  Matrix.h
 *  Assignment9
 *
 *  Created by Zach Gildersleeve on 4/8/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef MATRIX_H
#define MATRIX_H

#include "Vector.h"
#include "Point.h"
#include "Ray.h"
#include <iostream.h>
#include <iomanip.h>

class Matrix
{
	public:
		Matrix() {}
		//Matrix(
		Matrix(const Matrix &orig);
		
		void invert();
		void transpose();
		Matrix getInverse()const;
		Matrix getTranspose()const;
		
		Matrix & operator+= (const Matrix &r);
		Matrix & operator-= (const Matrix &r);
		Matrix & operator*= (const Matrix &r);
		Matrix & operator*= (float r);
		
		friend Matrix operator- (const Matrix &l, const Matrix &r);
		friend Matrix operator+ (const Matrix &l, const Matrix &r);
		friend Matrix operator* (const Matrix &l, const Matrix &r);
		// matrix mult. performed left to right
		friend Vector operator* (const Matrix &l, const Vector &r);
		friend Point operator*(const Matrix &l, const Point &r);

		// transform vector by a matrix
		friend Matrix operator* (const Matrix &l, float r);
		
		friend Point transformPoint(const Matrix &l, const Point &r); 
		friend Vector transformVector(const Matrix &l, const Vector &r);
		friend Ray transformRay(const Matrix &l, const Ray &r);
		
		friend Matrix zeroMatrix();
		friend Matrix identityMatrix();
		friend Matrix translate(float _x, float _y, float _z);
		friend Matrix scale(float _x, float _y, float _z);
		friend Matrix rotate(const Vector& axis, float angle);
		friend Matrix rotateX(float angle);    //
		friend Matrix rotateY(float angle);    // More efficient than arbitrary axis
		friend Matrix rotateZ(float angle);    //
		friend Matrix viewMatrix(const Vector& eye, const Vector& gaze, const Vector& up);
		friend ostream & operator<< (ostream & out, const Matrix & right_op);

		
		float determinant(); 
		float x[4][4];
};

inline float det3 (float a, float b, float c, 
                   float d, float e, float f, 
                   float g, float h, float i)
{ return a*e*i + d*h*c + g*b*f - g*e*c - d*b*i - a*h*f; }

#endif